
/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

File: data.h
Abstract: 
    Contains each class definition and any other defines
    required by the Data Base Class.

****************************************************************/

#ifndef DATA_INC_H
#define DATA_INC_H


/**********************/
/***  HEADER FILES  ***/
/**********************/

/* system */

#include <memory.h>
#include <stdio.h>
#include <string.h>

#include <ctype.h>
#include <iostream.h>

/* local */

#include "cool.h"


/*****************/
/***  DEFINES  ***/
/*****************/


/*****************/
/***  CLASSES  ***/
/*****************/

////////////////////////////////////////////////////////////////
//  CLASS - Data  //
////////////////////

// Class describing the data for the interpreter

class Data
{
private:

    // Properties/Attributes
  
    char      message [ MAX_MESSAGE_LEN   ];
    int       usedflag[ COOL_MAX_VARS_INT ];
    long int  varval  [ COOL_MAX_VARS_INT ];
    
public:

    //////////////////////////
    // Constructor & Destructor

    Data ( void );
    ~Data( void ) {;}

    /////////////////////////
    // Overloaded Functions

    // inline - overload [] (index) operator.
    // Return address of integer at varval[index] && automatically
    // dereferences it. Also set usedflag to show this variable has
    // been touched.

    long & operator[]( int index ) 
    { 
        usedflag[ index ] = 1;
        return( varval[index] ); 
    }


    /////////////////////////
    // Access Functions

    void Print( void );
    inline void GetMessage( char msg[] ) { strcpy( msg, message ); }
};



#endif
