/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

Base Class:  Instruction
Sub Class :  Conditional 
Class     :  IfThenElse
Member    :  Execute()
Abstract  :  
    IF (variable value at data index1 is non zero)
        execute all instrucs within if_condition
    ELSE 
        execute instrucs within else_condition.
    
References:
(1) Weiskamp, Keith & Flamig Bryan, "The Complete C++ Primer"
(2) Standish, Thomas, "Data Structures, Algorithms, and Software
    Principles in C"

*****************************************************************/


/*** INCLUDE FILES ***/

#include <stdio.h>
#include <string.h>

#include "cool.h"
#include "data.h"
#include "instruc.h"


int IfThenElse::Execute( class Data &data )
{

int   status;
class Instruction *iptr;


    status = SUCCESS;

    if( !end_flag )
    {
        /* Error: missing end-of-loop instruction */
        
        strcpy( message, ERROR_COND_NO_END_STR );
        return( status = ERROR_COND_NO_END );
    }

    if( data[ index1 ] != 0 )
        iptr = if_condition;
    else
        iptr = else_condition;

    while( iptr != NULL && 
           status == SUCCESS ) 
    {
        status = iptr->Execute( data );   
        iptr   = iptr->next;
    }

    if( status != SUCCESS )
        iptr->GetMessage( message );

return( status );
}
