/**************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

Class:    InputProc
Method:   GetStringInput()
Abstract: Get user string input and validate it. 

**************************************************************/

/*** INCLUDE FILES ***/

#include <stdio.h>
#include <string.h>

#include "cool.h"
#include "inproc.h"  


int InputProc::GetStringInput( FILE *fileptr, char *output_str  )
{

int  status;
char 
   str_buff[ MAX_STRING_LEN ],
   *cptr;


    status = SUCCESS;

    if( fileptr )
        cptr = fgets( str_buff, MAX_STRING_LEN, fileptr );
    else
        cptr = fgets( str_buff, MAX_STRING_LEN, stdin );
         
    if( !cptr )
    {
        sprintf( message, "\n%s", WARN_EOF_STR );
        return( WARN_EOF );
    }

    status = 
        ValidateInput( str_buff );
    if( status == SUCCESS )
        strcpy( output_str, str_buff );
 

return( status );
}
