
/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

Base Class:  Instruction
Member    :  GetDataIndex()
Abstract  :
    Assigns the index value for the data integer
    array. Validates ONLY that the first char is one of the
    legal data variables. Therefore the rest of the string 
    could be garbage and it wouldn't matter!
    
References:
(1) Weiskamp, Keith & Flamig Bryan, "The Complete C++ Primer"
(2) Class Notes
(3) Standish, Thomas, "Data Structures, Algorithms, and Software
    Principles in C"

*****************************************************************/


/*** INCLUDE FILES ***/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
       
#include "instruc.h"
#include "cool.h"


int Instruction::GetDataIndex( char *in_str, int &index )
{

int 
    status, tmp_int;


    status = SUCCESS;

    if( in_str == NULL || !(isalpha(in_str[0])) ) 
    {
        status = ERROR_DATA_VAR; 
        goto RETURN;
    }

    // Assign output index for the input data variable

    tmp_int = ( (in_str[0]) - 'A');

    if( tmp_int < 0 || tmp_int >= COOL_MAX_VARS_INT )
    {
        status = ERROR_DATA_VAR;
        goto RETURN;
    }

    index = tmp_int;


RETURN:

    if( status != SUCCESS )
    {
        sprintf( message, "%s%s", ERROR_DATA_VAR_STR, in_str );
    }


return( status );   
}
