
/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

Base Class:  Instruction
Member    :  GetDataInt()
Abstract  :
    Validates that the input string contains only digits.
    Does an ASCII to LONG INT translation to set the
    output variable.
    
References:
(1) Weiskamp, Keith & Flamig Bryan, "The Complete C++ Primer"
(2) Class Notes
(3) Standish, Thomas, "Data Structures, Algorithms, and Software
    Principles in C"

*****************************************************************/


/*** INCLUDE FILES ***/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>       

#include "instruc.h"
#include "cool.h"


int Instruction::GetDataInt( char *in_str, long &value )
{

int 
    status = SUCCESS;

char 
    *strptr;


    if( in_str == NULL ) 
    {
        status = ERROR_DATA_VAL_INT; 
        goto RETURN;
    }

    strptr = in_str;
    while( *strptr != '\0' )
    {
        if( !(isdigit(*strptr)) )
        {
            status = ERROR_DATA_VAL_INT;
            goto RETURN;
        }
        ++strptr;
    }

    value = atol( in_str );


RETURN:


    if( status != SUCCESS )
    {
        sprintf( message, "%s%s", ERROR_DATA_VAL_INT_STR, in_str );
    }


return( status );   
}
