/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

Base Class:  Instruction
Sub Class :  Sequential 
Class     :  LoopWhile
Member    :  Execute()
Abstract  :  
    Execute all instructions in loop 
    while ( the data variable value at index1 != 
            the data variable value at index2 )
    
References:
(1) Weiskamp, Keith & Flamig Bryan, "The Complete C++ Primer"
(2) Standish, Thomas, "Data Structures, Algorithms, and Software
    Principles in C"

*****************************************************************/


/*** INCLUDE FILES ***/

#include <stdio.h>
#include <string.h>

#include "cool.h"
#include "data.h"
#include "instruc.h"


int LoopWhile::Execute( class Data &data )
{

int   status;
class Instruction *iptr;


    status = SUCCESS;

    if( !end_flag )
    {
        /* Error: missing end-of-loop instruction */
        
        strcpy( message, ERROR_LOOP_NO_END_STR );
        return( status = ERROR_LOOP_NO_END );
    }

    
    // assign here. If there are no instructions, we
    // won't get caught in an infinite loop.

    iptr = start;

    while( iptr != NULL &&
           status == SUCCESS && 
           data[ index1 ] != data[ index2 ] )
    {
        while( iptr != NULL && 
               status == SUCCESS  ) 
        {
            status = iptr->Execute( data );   
            iptr   = iptr->next;
        }

        iptr = start;
    }

           
    if( status != SUCCESS )
        iptr->GetMessage( message );


return( status );
}
