
/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

File: parse.h
Abstract: 
    Contains each class definition and any other defines
    required by the Parser Base Class.

****************************************************************/

#ifndef PARSE_INC_H
#define PARSE_INC_H


/**********************/
/***  HEADER FILES  ***/
/**********************/

/* system */

#include <memory.h>
#include <stdio.h>
#include <string.h>

#include <ctype.h>
#include <iostream.h>

/* local */

#include "cool.h"


/*****************/
/***  DEFINES  ***/
/*****************/


/*****************/
/***  CLASSES  ***/
/*****************/

////////////////////////////////////////////////////////////////
//  CLASS - PARSER  //
//////////////////////

// Class describing an Instruction Parser

class Parser
{
private:

    // Properties/Attributes

    char  message[ MAX_MESSAGE_LEN ];

    // Member Functions


public:

    //////////////////////////
    // Constructor & Destructor

    Parser ( void ) { message[0] = '\0'; }
    ~Parser( void ) { return;}

    /////////////////////////
    // Access Functions

    class Instruction * GetInstruc( char in_str[] );
    inline void GetMessage( char msg[] ) { strcpy( msg, message ); }

};


#endif
