/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

Class:    Stack
Method:   Push()
Abstract: 
    Will pop the node at the head of the stack, assign
    a Pointer to an Instruction object as output,
    and decrement the num_nodes node counter.
   
****************************************************************/

#include <stdio.h>

#include "cool.h"
#include "inproc.h"
#include "instruc.h"


int Stack::Pop( class Instruction **iptr )
{

int   status = SUCCESS;
class StackNode *tmp_node;


// Begin...

if( !(Empty()) )
{
    tmp_node = list;                  // Point to top-of-stack.
    *iptr = tmp_node->GetDataItem();   // Assign popped output.
    list = tmp_node->GetNextPtr();    // Assign new top-of-stack.
    --num_nodes;                      // Decrement num stack nodes.
    delete tmp_node;                  // Free popped node memory.
}
else
{
    *iptr = NULL;
    strcpy( message, ERROR_STACK_EMPTY_STR );
    return( status = ERROR_STACK_EMPTY );
}

return( status );

}  
