/***************************************************************

Craig Flory
CS307-01
Object Oriented Programming with C++
Instructor: Jagdish Bansiya
Fall Semester 1995

Date:    04 Dec 1995
Project: Language Interpreter

Class:    Stack
Method:   Push()
Abstract: 
    Given an Instruction object pointer, will create a new
    stack node, copy the item into the node, and increment
    the num_nodes node counter.
   
****************************************************************/

#include <stdio.h>

#include "cool.h"
#include "instruc.h"
#include "inproc.h"


int Stack::Push( class Instruction *iptr )
{

int   status = SUCCESS;
class StackNode *new_node;


// Begin...

if( !(Full()) )
{
    new_node = new StackNode;
    if( new_node == NULL )
    {
        strcpy( message, ERROR_ALLOC_STR );
        return( status = ERROR_ALLOC );
    }

    new_node->SetNextPtr ( list );   // Point to Stack's node list
    new_node->SetDataItem( iptr );   // Assign data
    list = new_node;                 // Assign new top-of-stack
    ++num_nodes;                     // Increment num of nodes 
}
else
{
    strcpy( message, ERROR_STACK_FULL_STR );
    return( status = ERROR_STACK_FULL );
}

    
return( status );
} 
