
// File name:  if.cpp
// Author:   Rebecca Barry
// Purpose:  provides the implementation of the methods of the if_then and else classes

#include "cool.h"
extern data vars;
extern interpreter interpret;
extern short selection_flg;

// *************** class if_then methods  **********************//
//
// Method to check the syntax of the if_then instruction
int if_then::check_syntax(char* string)
{
	char var;
	char delimeter1 = '(';
	char delimeter2 = ')';
	char instruct[INSTRUCT_LEN];
	char *ptr, *ptr1;
	int status = SUCCESS;

	//determine the if_then variable  that we will assign 
	status = interpret.parse_variable(string, delimeter1,
																		delimeter2,var);
	if(status == SUCCESS)
	{
		//determine the if_then variable index of the variable
		status = interpret.set_var_index(var,sel_var_index);
		
		if(status == SUCCESS)
		{
			//Ensure that "THEN" is part of the instruction
			ptr = strchr(string, ')' );
			ptr1 = ptr + 1;
			status = interpret.parse_instruction(ptr1, instruct);
			if(strcmp(instruct, "THEN") != 0)
				status = INVALID_INST;
			}
		}
	return status;
}; //end of if_then::check_syntax

// Method to execute the if_then instruction
void if_then::execute(void)
{
	if(vars.variables[sel_var_index] > 0)
		selection_flg = EXECUTE;
	else
		selection_flg = DO_NOT_EXECUTE;
};

// my_id method  provides the type of instruction 
void if_then::my_id(char* my_id)
{
		strcpy(my_id,"if_then");
};

// *************** class ELSE methods  **********************//
//
// Method to check the syntax of the ELSE instruction
int ELSE::check_syntax(char* string)
{
	return SUCCESS;
};
	
void ELSE::execute(void)
{
	if(selection_flg == EXECUTE)
		selection_flg = DO_NOT_EXECUTE;
	else
		selection_flg = EXECUTE;
};

// Method to return the name of the instruction
void ELSE::my_id(char* my_id)
{
		strcpy(my_id,"ELSE");
};

// *************** class endif methods  **********************//
//
// Method to check the syntax of the endif instruction
int endif::check_syntax(char* string)
{
	return SUCCESS;
};
	
// Method to execute the endif instruction
void endif::execute(void)
{
		selection_flg = EXECUTE;
};

// Method to return the name of the endif instruction
void endif::my_id(char* my_id)
{
		strcpy(my_id,"endif");
};
