
// file name:  instructions.cpp
// author:  Rebecca Barry
//
// Purpose:  provides the implementation of the methods
//					 of the instruction and sequential classes.

// *************** class instruction methods  **********************//
//

#include "cool.h"
extern interpreter interpret;

// *************** constructor method  **********************//
instruction::instruction(void)
	{
		variable_index1=-1;
		variable_index1=-1;
		value = 0;
	};

// *************** my_id method  **********************//
void instruction::my_id(char* my_id)
{
		strcpy(my_id,"instruction");
};

// *************** class sequential methods  **********************//
//
//********************** constructor  method  ***********************

sequential::sequential(void)
{
	variable_index1 = -1;
	variable_index2 = -1;
	value = 0;
};
 
//********************** check_syntax method  ***********************

int sequential::check_syntax(char* string)
{
	char var;
	char delimeter1 = '(';
	char delimeter2 = ',';
	char *ptr;
	int len = 0;
	int status = SUCCESS;

	//determine the first variable  
	status = interpret.parse_variable(string, delimeter1,
																		delimeter2, var);
	if(status == SUCCESS)
	{
		//determine the variable index of the variable
		status = interpret.set_var_index(var,variable_index1);
		if(status == SUCCESS)
		{
	    //determine the value that we will assign to the variable
			delimeter1 = ',';
			delimeter2 = ')';
			status = interpret.parse_value(string, delimeter1,
																			delimeter2, value);
			if(status == NO_VALUE)
			{
				// IF no value entered, determine the the second variable 
				status = interpret.parse_variable(string, delimeter1,
																		delimeter2, var);
				if(status == SUCCESS)
				{
					//determine the variable index of the variable
					status = interpret.set_var_index(var,variable_index2);
				}
			}//end if(status == NO_VALUE)
		}// end if(status == SUCCESS) from set_var_index
	}// end if(status == SUCCESS) from parse_variable
	if (status == SUCCESS)
	//  Make sure that there is no garbage after the instruction
	{
		ptr = strchr(string,')');
		len = strlen(string) - 1;
		if((ptr - string) != len)status = INVALID_SYNTAX;
	}
return status;
};
