
// File name menu.cpp

// This file contains the implementation of the menu methods

#include "cool.h"
extern interpreter interpret;
extern data vars;

// *** Menu::io_process method   ****
 
int Menu::open_file(char *file_name, FILE **stream)
{
	int status = SUCCESS;
	ios::sync_with_stdio();

	*stream = fopen(file_name, "r");
	if(!*stream)status = FILE_OPEN_ERR;

	return status;
	};

void Menu::read_input(char *string)
{
	char junk;									//used to get rid of end of line character
	char temp[512];
	int len;

	cin.get(temp,512);
	cin.get(junk);
	len = strlen(temp);
	interpret.remove_spaces(temp,string,len);
};

int Menu::read_file(FILE *input_file, char *string)
{
	char temp[512];
	int n = 20;
	int len;
	int status = SUCCESS;

	ios::sync_with_stdio();
	fgets(temp,80,input_file);
	len = strlen(temp);
	if(len>3)temp[len-1] = '\0';
	interpret.remove_spaces(temp,string,len);
	return status;
};

void Menu::display_error_msg(int status,int line_count)
{
	if(status == INVALID_VAR)
		cout << "INVALID variable on line " << line_count << "\n"; 
	else if(status == INVALID_INST)
		cout << "INVALID Instruction on line " << line_count << "\n"; 
	if(status == INVALID_SYNTAX)
		cout << "INVALID Syntax \n";
	else if (status == NO_VALUE)
		cout << "No Value Entered \n";
	else if (status == NO_INSTRUCT)
		cout << "No Instruction Entered \n";
	else if (status == OUT_OF_RNG)
		cout << "Number is too large or too small for an integer\n";
	else if (status == LOOP_IN_LOOP)
		cout << "Nested loops are not allowed \n";
	else if (status == FILE_OPEN_ERR)
		cout << "Error opening file \n";
	else if (status == TOO_MANY_CHAR)
		cout << "Variable has more than 1 character \n";
	else if (status == UNDEFINED)
	{
		cout << "undefined  " << vars.last_char;
		cout <<"  on line " << line_count << "\n";
	}
};
	
