
import java.util.*;
import java.io.*;
/**
 * Generic Grep Utility Class.
 * 
 */
public class Grep extends java.lang.Object {
 int lineNumber;
 Vector fileList;
 String currentFileName;
 String filePath;
 String pattern;
 FileProcessor processor = new FileProcessor();
 GrepVisitor visitor;

/**
 * This method was created by a SmartGuide.
 */
public Grep() {
}
/**
 * Accept a visitor object.
 * @param aVisitor .GrepVisitor
 */
public void acceptVisitor(GrepVisitor aVisitor) {
	visitor = aVisitor;
	return;
}
/**
 * Read each line of a file and request visitor object
 * to visit 
 */
public void grepFile() {

	while(processor.read() != null){
			   lineNumber++;
				visitor.visit(this); }

	return;
}

/**
 * Initialize file(s) to grep
 */
public void initFileList() {
File aFile = new File( filePath );
	fileList = new Vector();
	if(aFile.isDirectory()) {
		 String dir[] = aFile.list();  
		 for (short i = 0; i < dir.length;i++)
				{ fileList.addElement( filePath + "\\"+dir[i]);}
		 }
	else { fileList.addElement(filePath); }	 
				
	return;
}
/**
 * Invoke Utility from command line
 * @param args java.lang.String[]
 */
public static void main(String args[]) {

	if (args.length < 2) 
		{ System.out.println("Usage: java Grep <file path>, <pattern>");
			return ;}	

	Grep aGrep = new Grep();
	aGrep.filePath = args[0];
	aGrep.pattern = args[1];
	// Create and accept a Visitor
	aGrep.acceptVisitor( new GrepSimplePattern() );
	aGrep.process();
	return;
}
/**
 * Grep file(s) pattern.
 */
public void process() {

			initFileList();
			for (short j=0;j < fileList.size(); j++) {
				currentFileName = (String) fileList.elementAt(j);	
				lineNumber = 0;
				processor.open( currentFileName );
				lineNumber = 0;
				this.grepFile();
				processor.close();}
				
	return;
}
}
