#ifndef __DSERROR_H__
#define __DSERROR_H__
/*
Copyright (c) 1998 by UWI Unisoft Wares Inc.
   UWI.Com -- The Internet Forms Company
   400 - 1095 McKenzie Ave.
   Victoria, British Columbia Canada V8P 2L5
   1-888-517-2675
   http://www.uwi.com

Author: John Boyer

Neither John Boyer, UWI Unisoft Wares Inc., nor Dr. Dobb's Journal will be
   liable under any circumstances for any direct or indirect damages arising
   from any use, direct or indirect, of this software. This software is
   provided with no warranty, implicit or explicit.

UWI Unisoft Wares Inc. grants you license to use this software in your programs
under the following conditions:
1) This copyright and license message must remain in this source code.
2) The following copyright message must appear in the program credits and
        documentation acknowledgements of software containing this library

   The Digital Signature Library for Microsoft(R) CryptoAPI
   Written By John Boyer Copyright (c) 1998 by UWI Unisoft Wares Inc.
*/

#include "charp.h"

#define DSFREECRYPTENV		0
#define DSPREPCRYPTENV		1
#define DSSIGNMESSAGE		2
#define DSVERIFYSIGNATURE	3
#define DSGETIDENTITYLIST	4
#define DSGETCERTLIST		5
#define _DSGETSUBJECTFROMCERT	6
#define _DSFINDRDNATTR		7
#define _DSFINDCERTIFICATE	8
#define _DSGETISSUERCERT	9
#define _DSGETCERTCHAIN		10
#define _DSCRYPTACQUIRECONTEXT	11
#define _DSGETVERIFICATIONCERTIFICATE	12
#define _DSCHECKCERTIFICATE	13
#define _DSTESTSIGNATUREPROPERTY	14

#define ME_NOMESSAGE			0
#define ME_INVALIDPARAMETERS            1
#define ME_NOMEMORY			2
#define ME_INTERNALFUNCTIONFAILED	3
#define ME_OSERROR			4
#define DS_ERR_INVALIDHASHALG		5
#define DS_ERR_CERTNOTFOUND		6
#define DS_ERR_CERTEXPIRED		7

#define MENoMemory(FunctionCode) MELogError(0,FunctionCode,__LINE__,ME_NOMEMORY,NULL)

#define MEInvalidParameters(FunctionCode) MELogError(0,FunctionCode,__LINE__,ME_INVALIDPARAMETERS,NULL)

#define MELogErrorInfoStr(lastError, FunctionCode, ErrorCode, ErrorInfo) \
	MELogError(lastError, FunctionCode, __LINE__, ErrorCode, ErrorInfo)

#define MELogOSErrorStr(lastError, FunctionCode, ErrorInfo) \
	MELogError(lastError, FunctionCode, __LINE__, ME_OSERROR, ErrorInfo)

#define MELogErrorStr(lastError, FunctionCode, ErrorCode, ErrorInfo) \
	MELogError(lastError, FunctionCode, __LINE__, ErrorCode, ErrorInfo)

void MELogError(int lastError, int FunctionCode, int LineNum, int ErrorCode, charP ErrorInfo);

#endif

