VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "oCGI2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "allows you to create CGI enabled applications with any OLE automation enabled 32 bit language."
' oCGI is the property of Ofer LaOr (oWare) 1997.
'    It is licensed for the use of this system only!
'    oCGI cannot be resold without the author's explicit consent.
' Version 2.0.51
'   * fix Inet Explorer 4.x bug with cookies' path name.
' Version 2.0.50
'   * added static ReadPOST so that it will only read from console once.
' Version 2.0.47
'   * added MaxPost capability (must be changed before call to ProcessCGI).
' Version 2.0.45
'   * fixed bug in DeleteVirtualCookie by creating the RecursiveDelete function
'   * added several new CGI encapsulating functions
' Version 2.0
'   * oCGI is now an ActiveX library.
' version 1.1
'   * added virtual cookies.
'   * added non-unique names for virtual cookies.
'   * added MAX_POST as a constant holding the number of chars for POSTs
' version 1.0e
'   * added ParamType class and the ability to scan through cookies and parameters.
'   * added the Clear collection ability.

Option Explicit

Const STD_INPUT_HANDLE = -10&
Const STD_OUTPUT_HANDLE = -11&

Const NBlock = 3800
Const DEFAULT_MAX_POST = 10000

Private Declare Function GetStdHandle Lib "kernel32" (ByVal nStdHandle As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long

' keeps the parameter names
Public cParameters As New Collection, cCookies As New Collection
Attribute cParameters.VB_VarProcData = ";Data"
Attribute cParameters.VB_VarHelpID = 34
Attribute cParameters.VB_VarDescription = "Contains all of the parameters that were passed to the oCGI session."
Attribute cCookies.VB_VarProcData = ";Data"
Attribute cCookies.VB_VarHelpID = 33
Attribute cCookies.VB_VarDescription = "contains all of the cookie and virtual cookie values for a particular session."

'Max number of bytes allowed as post parameter
Public MaxPost As Long
Attribute MaxPost.VB_VarHelpID = 37
Attribute MaxPost.VB_VarDescription = "Maximum size of incoming submission text!"

' have we started writing HTTP yet?
Dim fStartedCGI As Boolean

' value of compressed cookies
Dim VirtualTTL As Integer
Dim fModifiedVirtual As Boolean, fCommittedVirtual As Boolean
Dim nVirtualCookies As Integer, sVirtualCookies As String
Const NMaxVirtualCookies = 19 ' Netscape's upper limit is 20 cookies per site!

'This function clears a collection out.  Useful for deleting the cookie and parameter collections.
Private Sub ClearCollection(cCollection As Collection)
    Dim iPos As Integer
    For iPos = 1 To cCollection.Count
        cCollection.Remove 1
    Next
End Sub

'This function translates virtual cookies into standard cookies.  Called internally
Private Sub CommitVirtualCookies()
    If Not fModifiedVirtual Then Exit Sub ' not needed, nothing's changed
    ' break it down into any number of CC blocks and save them.
    Dim sTotal As String, sCurrent As String
    sTotal = sVirtualCookies

    Dim i As Integer
    For i = 1 To NMaxVirtualCookies
        sCurrent = Left$(sTotal, NBlock)
        sTotal = Mid$(sTotal, NBlock)
        
        If (sCurrent <> "") Then
            If VirtualTTL > 0 Then
                WriteCookie "_" + CStr(i), sCurrent, ReadServerName, ReadScriptName, CDate(Now + VirtualTTL)
            Else
                WriteCookie "_" + CStr(i), sCurrent, ReadServerName, ReadScriptName
            End If
        Else
            ' if less than or equal to compressed cookies, delete the extra cookie!
            If (i <= nVirtualCookies) Then
                If VirtualTTL > 0 Then
                    WriteCookie "_" + CStr(i), "", ReadServerName, ReadScriptName, CDate(Now - VirtualTTL)
                Else
                    WriteCookie "_" + CStr(i), "", ReadServerName, ReadScriptName
                End If
            End If
        End If
    Next
    fCommittedVirtual = True
    fModifiedVirtual = False
End Sub


' Deletes a virtual cookie.  This will only work if it is run before StartHTTP or WriteCGI.
' sName= name of virtual cookie.
' sValue= value of cookie.  If not specified, the system assumes unique cookie names and deletes the first virtual
'           Virtual cookie it finds with the name specified.  Otherwise, the function only deletes the cookie if it
'           finds both name and value the same!
Public Sub DeleteVirtualCookie(sName As String, Optional sValue As Variant)
Attribute DeleteVirtualCookie.VB_Description = "Deletes a virtual cookie with a given name and optional value.  ProcessVirtualCookies must have been called BEFOREHAND!"
Attribute DeleteVirtualCookie.VB_HelpID = 3
    Dim iPos As Integer, iEnd As Integer, sNewValue As String, sNewCookies As String
    sNewValue = sName + IIf(IsMissing(sValue), "=", "=" + CStr(sValue))
    
    ' surgically remove the value from the virtual cookie string.
    sNewCookies = RecursiveDelete(sVirtualCookies, sNewValue, IsMissing(sValue))
    If (sVirtualCookies <> sNewCookies) Then fModifiedVirtual = True
    sVirtualCookies = sNewCookies
End Sub


'Is this communication secure.
Public Function ReadServerSecured() As Boolean
Attribute ReadServerSecured.VB_Description = "This function returns whether the communication between web server and browser is secured (using SSL)."
Attribute ReadServerSecured.VB_HelpID = 36
    ReadServerSecured = IIf(Environ("SERVER_PORT_SECURE") = "0", False, True)
End Function

'Returns a detailed string specifying the browser the client is using.
Public Function ReadUserAgent() As String
Attribute ReadUserAgent.VB_Description = "Gets the browser type for the current user connection."
Attribute ReadUserAgent.VB_HelpID = 4
    Dim iPos As Integer, sUserAgent As String
    
    sUserAgent = Environ("HTTP_USER_AGENT")
    iPos = InStr(sUserAgent, "MSIE")
    If (iPos > 0) Then
        sUserAgent = "Microsoft Internet Explorer (" + Mid$(sUserAgent, iPos + 5)
    Else
        iPos = InStr(sUserAgent, "Mozilla")
        If iPos >= 0 Then
            sUserAgent = "Netscape or compatible " + Mid$(sUserAgent, iPos + 8)
        End If
    End If
    ReadUserAgent = sUserAgent
End Function

'Returns the server name.
Public Function ReadServerName() As String
Attribute ReadServerName.VB_Description = "Retrieves the server's host name."
Attribute ReadServerName.VB_HelpID = 26
    ReadServerName = Environ("SERVER_NAME")
End Function

'Returns the gateway inteface.
Public Function ReadGatewayInterface() As String
Attribute ReadGatewayInterface.VB_Description = "returns the interace type, for example ""CGI/1.1"""
Attribute ReadGatewayInterface.VB_HelpID = 32
    ReadGatewayInterface = Environ("GATEWAY_INTERFACE") ' CGI/1.1
End Function

'Returns the server port
Public Function ReadServerPort() As String
Attribute ReadServerPort.VB_Description = "Returns the port which the server is communicating with the browser."
Attribute ReadServerPort.VB_HelpID = 35
    ReadServerPort = Environ("SERVER_PORT") ' 80
End Function

'Returns the script name.
Public Function ReadScriptName() As String
Attribute ReadScriptName.VB_Description = "Retrieves the script's name."
Attribute ReadScriptName.VB_HelpID = 28
    ReadScriptName = Environ("SCRIPT_NAME")
End Function
Public Sub ProcessVirtualCookies(Optional NewVirtualTTL As Variant)
Attribute ProcessVirtualCookies.VB_Description = "This procedure must be called prior to any Virtual cookie operations.  It prepares the system for virtual cookie commands."
Attribute ProcessVirtualCookies.VB_HelpID = 6
    If (Not IsMissing(NewVirtualTTL)) Then
        VirtualTTL = NewVirtualTTL
    End If
    
    nVirtualCookies = 0
    sVirtualCookies = ""
    Dim i As Integer, sCookie As String
    For i = 1 To NMaxVirtualCookies
        sCookie = ReadCookie("_" + CStr(i))
        If (sCookie <> "") Then
            sVirtualCookies = sVirtualCookies + sCookie
            nVirtualCookies = i
            
            'remove this cookie from the cookie list.
            cCookies.Remove ("_" + CStr(i))
        End If
    Next
    
    If (sVirtualCookies = "") Then Exit Sub
    
    Dim request As String
    request = sVirtualCookies
    ' now, untangle the mess...
    Dim iPos As Integer
    Do
        ' look for the first appearance of the= sign.
        iPos = InStr(request, "=")
        If (IsNull(iPos) Or iPos = 0) Then
            Exit Do
        End If

        Dim sName As String, sVal As String
        sName = Left$(request, iPos - 1)
        sVal = Mid$(request, iPos + 1)

        iPos = InStr(sVal, "&")
        If (IsNull(iPos) Or iPos = 0) Then
            request = ""
        Else
            sVal = Left$(sVal, iPos - 1)
            request = Trim$(Mid$(request, Len(sVal) + Len(sName) + 3))
        End If
       
        Dim entry As ParamType
        Set entry = New ParamType
        entry.Name = sName
        entry.Value = sVal
        
        On Error GoTo DuplicateKeyErr
        cCookies.Add Item:=entry, Key:=sName
        On Error GoTo 0

    Loop
    Exit Sub
DuplicateKeyErr:
    If Err.Number <> 457 Then Exit Sub ' serious error!
    cCookies.Add Item:=entry ' no key!
    Resume Next
End Sub


' Read a parameter with name sName.  Needs ProcessParams to be called BEFOREHAND!
Public Function ReadParam(sName As String) As String
Attribute ReadParam.VB_Description = "Retrieves a normal parameter."
Attribute ReadParam.VB_HelpID = 16
Attribute ReadParam.VB_UserMemId = 0
On Error GoTo EndReadParam ' parameter that hasn't shown
    ReadParam = ""
    ReadParam = cParameters(sName).Value
EndReadParam:
    Exit Function
End Function

'get the IP address of the client
Public Function ReadRemoteAddress() As String
Attribute ReadRemoteAddress.VB_Description = "Retrieves User's remote address."
Attribute ReadRemoteAddress.VB_HelpID = 18
    ReadRemoteAddress = Environ("REMOTE_ADDR")
End Function

'get the reverse DNS for the IP address of the client
Public Function ReadRemoteHost() As String
Attribute ReadRemoteHost.VB_Description = "Retrieves the session's remote user's host name.  This can be a reverse name lookup of the user's IP address or his actual machine name."
Attribute ReadRemoteHost.VB_HelpID = 22
    ReadRemoteHost = Environ("REMOTE_HOST")
End Function


'Get the email address (if available) of the client
Public Function ReadRemoteFrom() As String
Attribute ReadRemoteFrom.VB_Description = "Retrieve remote from.  This only works with Netscape servers and Netscape browsers - whereas the user's email address will be shown here."
Attribute ReadRemoteFrom.VB_HelpID = 20
    ReadRemoteFrom = Environ("HTTP_FROM")
End Function


' clear the HTTP junk off of the parameters
Private Sub ClearJunk(param As String)
    Dim iPos As Integer, i As Integer
    Dim newParam As String
    
    ' first clear all + signs.
    Do
        iPos = InStr(param, "+")
        If (IsNull(iPos) Or iPos = 0) Then
            Exit Do
        End If
        param = Left$(param, iPos - 1) & " " & Mid$(param, iPos + 1)
    Loop

    ' clear all %.
    Do
        iPos = InStr(param, "%")
        If (IsNull(iPos) Or iPos = 0) Then
            Exit Do
        End If

        newParam = "&H" + Mid$(param, iPos + 1, 2)
        param = Left$(param, iPos - 1) & Chr$(CInt(newParam)) & Mid$(param, iPos + 3)
    Loop
    
End Sub

' Set all of the parameters to the input
Public Sub ProcessCGI(Optional sCommand As Variant)
Attribute ProcessCGI.VB_Description = "Process cookie, parameters and other CGI information."
Attribute ProcessCGI.VB_HelpID = 39
    SetParams ReadCGI(sCommand)
    SetCookies ReadCookieString()
End Sub
Private Function RecursiveDelete(sVirtualCookies As String, sMatch As String, fPartialMatch As Boolean) As String
    If sMatch = sVirtualCookies Then
        RecursiveDelete = ""
        Exit Function
    End If
    
    If fPartialMatch Then
        Select Case InStr(sVirtualCookies, sMatch)
            Case 0 ' partial match - couldn't find the string, just exit!
                RecursiveDelete = sVirtualCookies
                Exit Function
            Case 1 ' found it at the beginning!
                If (InStr(sVirtualCookies, "&") < 1) Then ' no end, i.e., this is it!
                    RecursiveDelete = ""
                    Exit Function
                End If
        End Select
    Else ' should at least find the beginning of it, otherwise, why waste the time?
        If InStr(sVirtualCookies, sMatch) = 0 Then
            RecursiveDelete = sVirtualCookies
        End If
    End If
    
    Dim iPos As Integer, sLeft As String, sRight As String
    iPos = InStr(sVirtualCookies, "&")
    If (iPos < 1) Then ' if here, must be a full match (case 1 handles this otherwise!).
        RecursiveDelete = sVirtualCookies
        Exit Function
    End If
    sLeft = RecursiveDelete(Left$(sVirtualCookies, iPos - 1), sMatch, fPartialMatch)
    sRight = RecursiveDelete(Mid$(sVirtualCookies, iPos + 1), sMatch, fPartialMatch)
    If (sLeft = "") Then
        RecursiveDelete = sRight
    ElseIf (sRight = "") Then
        RecursiveDelete = sLeft
    Else
        RecursiveDelete = sLeft + "&" + sRight
    End If
End Function

' Process the cookie input and place it in the cookie collection
Private Sub SetCookies(ByVal request As String, Optional fDeleteCookies As Variant)
    If (IsMissing(fDeleteCookies)) Then
        ClearCollection cCookies
    ElseIf fDeleteCookies Then
        ClearCollection cCookies
    End If
    
    ' skip trailing CR/LF (if there is one...)
    Do While (Len(request) > 0)
        If ((Right$(request, 1) = Chr$(13)) Or (Right$(request, 1) = Chr$(10))) Then
            request = Mid$(request, 1, Len(request) - 1)
        Else
            Exit Do
        End If
    Loop

    Dim iPos As Integer
    Do
        ' look for the first appearance of the= sign.
        iPos = InStr(request, "=")
        If (IsNull(iPos) Or iPos = 0) Then
            Exit Do
        End If

        Dim sName As String, sVal As String
        sName = Left$(request, iPos - 1)
        sVal = Mid$(request, iPos + 1)

        iPos = InStr(sVal, ";")
        If (IsNull(iPos) Or iPos = 0) Then
            request = ""
        Else
            sVal = Left$(sVal, iPos - 1)
            request = Trim$(Mid$(request, Len(sVal) + Len(sName) + 3))
        End If

        ClearJunk sName
        ClearJunk sVal
        
        Dim entry As ParamType
        Set entry = New ParamType
        entry.Name = Trim$(sName)
        entry.Value = Trim$(sVal)
        
        On Error GoTo DuplicateKeyErr
        cCookies.Add Item:=entry, Key:=sName
        On Error GoTo 0

    Loop
    Exit Sub
DuplicateKeyErr:
    If Err.Number <> 457 Then Exit Sub ' serious error!
    cCookies.Add Item:=entry ' no key!
    Resume Next
    
End Sub


' Process the input and place it in the parameters
Private Sub SetParams(ByVal request As String, Optional fDeleteParameters As Variant)
    ' delete params if they are missing
    If (IsMissing(fDeleteParameters)) Then
        ClearCollection cParameters
    ElseIf fDeleteParameters Then
        ClearCollection cParameters
    End If
      
    ' skip trailing CR/LF
    Do While (Len(request) > 0)
        If ((Right$(request, 1) = Chr$(13)) Or (Right$(request, 1) = Chr$(10))) Then
            request = Mid$(request, 1, Len(request) - 1)
        Else
            Exit Do
        End If
    Loop
    
    Dim iPos As Integer
    Do
        ' look for the first appearance of the= sign.
        iPos = InStr(request, "=")
        If (IsNull(iPos) Or iPos = 0) Then
            Exit Do
        End If

        Dim sName As String, sVal As String
        sName = Left$(request, iPos - 1)
        sVal = Mid$(request, iPos + 1)


        iPos = InStr(sVal, "&")
        If (IsNull(iPos) Or iPos = 0) Then
            request = ""
        Else
            sVal = Left$(sVal, iPos - 1)
            request = Mid$(request, Len(sVal) + Len(sName) + 3)
        End If

        ClearJunk sName
        ClearJunk sVal
        Dim entry As ParamType
        Set entry = New ParamType
        entry.Name = sName
        entry.Value = sVal
        ' ok duplicate names can reoccur, bypass them this way:
        On Error GoTo DuplicateKeyErr
        cParameters.Add Item:=entry, Key:=sName
        On Error GoTo 0

    Loop
    Exit Sub
DuplicateKeyErr:
    If Err.Number <> 457 Then Exit Sub ' serious error!
    cParameters.Add Item:=entry ' no key!
    Resume Next
End Sub


' Read a cookie with the name "sCookie" - returns the value
Public Function ReadCookie(sCookie As String) As String
Attribute ReadCookie.VB_Description = "Retrieves a normal cookie."
Attribute ReadCookie.VB_HelpID = 10
On Error GoTo ExitReadCookie ' probably wrong cookie
    ReadCookie = ""
    ReadCookie = cCookies(sCookie).Value
ExitReadCookie:
    Exit Function
End Function


' Get ALL of the cookie values
Public Function ReadCookieString() As String
Attribute ReadCookieString.VB_Description = "Retrieves the entire cookie string."
Attribute ReadCookieString.VB_HelpID = 12
    ReadCookieString = Environ("HTTP_COOKIE")
End Function



' Get the input from CGI
Public Function ReadCGI(Optional sISINDEX As Variant) As String
Attribute ReadCGI.VB_Description = "Retrieves the parameter string for GET,PUT, POST and ISINDEX methods."
Attribute ReadCGI.VB_HelpID = 8
    Select Case Environ("REQUEST_METHOD")
        Case "GET", "PUT", "HEAD": ' no need, already done beforehand!
            ReadCGI = Environ("QUERY_STRING")
        Case "POST":
            ReadCGI = ReadPOST()
        Case Else: ' when everything else - debugging or ISINDEX!
            ' check if surrounded by quote marks (=run manually from command line!).
            If (Not IsMissing(sISINDEX)) Then
                If (Len(sISINDEX) >= 2) Then
                    sISINDEX = Trim$(sISINDEX)
                    If (Left$(sISINDEX, 1) = """") And (Right$(sISINDEX, 1) = """") Then
                        sISINDEX = Mid$(sISINDEX, 2, Len(sISINDEX) - 2)
                    End If
                End If
            End If

            ReadCGI = sISINDEX
    End Select
End Function

' Start writing CGI
Private Sub startCGI()
    If Not (fStartedCGI) Then
        If (Not fCommittedVirtual And (Len(sVirtualCookies) > 0) Or fModifiedVirtual) Then
            CommitVirtualCookies
        End If
        fStartedCGI = True
        WriteCGI "Content-type: text/html" + vbCrLf + vbCrLf + "<!--Piped through oCGI " + CStr(App.Major) + "." + CStr(App.Minor) + "." + CStr(App.Revision) + " by Ofer LaOr - oWare (all rights reserved)-->" + vbCrLf, False
    End If
End Sub

' Write a cookie out.  This will only work if it is run before StartHTTP or WriteCGI.
' name= name of cookie.
' value= value of cookie.
' domain= domain name for this cookie (www.microsoft.com)
' path = where in the domain is this cookie relevant? (/scripts/myprogram.exe)
' expires= when does this cookie expire?  To delete a cookie, put a date that has already passed here.
'          note, if expired is not entered, the cookie will be deleted when the current session is finished.
Public Sub WriteCookie(sName As String, sValue As String, sDomain As String, Optional sPath As Variant, Optional expires As Variant)
Attribute WriteCookie.VB_Description = "Write a standard cookie.  Only works BEFORE any WriteCGI is used."
Attribute WriteCookie.VB_HelpID = 29
    Dim sCookie As String
    sCookie = "Set-Cookie: " + sName + "=" + sValue + ";"

    If Not IsMissing(sDomain) Then
        If (sDomain <> "") Then
            sCookie = sCookie + " domain=" + sDomain + ";"
        End If
    End If
        
    If Not IsMissing(sPath) Then
        If (sPath <> "") Then
            ' Internet explorer 4.x specifically!
            If (InStr(Environ("HTTP_USER_AGENT"), "MSIE")) Then
                ' kill everything after the last forward slash
                Dim iPos As Integer, sChar As String
                For iPos = Len(sPath) To 1 Step -1
                    sChar = Mid$(sPath, iPos, 1)
                    If (sChar = "/") Or (sChar = "\") Then
                        ' make sure there's an extension...
                        ' if not, this could be something the user passed...
                        ' along as a parameter!
                        If (InStr(Mid$(sPath, iPos), ".")) Then
                            ' this is it, kill trailing string
                            sPath = Mid$(sPath, 1, iPos)
                        End If
                        Exit For
                    End If
                Next
            End If
            sCookie = sCookie + " path=" + sPath + ";"
        End If
    Else
        sCookie = sCookie + " path=/" + ";"
    End If
    If Not IsMissing(expires) Then
        sCookie = sCookie + " expires=" + Format(expires, "dddd, dd-mmm-yyyy hh:mm:ss") '+ " GMT;"
    End If
    WriteCGI sCookie + Chr$(10), False
End Sub


' Write a virtual cookie out.  This will only work if it is run before StartHTTP or WriteCGI.
' name= name of virtual cookie.
' value= value of cookie.
' fNotUnique= if this is not specified, the system assumes that the name is unique and deletes any other virtual
'           cookie with the same name it may find.  If specified as true, the system does not assume that Virtual
'           cookie names are unique (ergo, one must scan through the cookie collection to find the cookie of choice).
Public Sub WriteVirtualCookie(sName As String, sValue As String, Optional fNotUnique As Variant)
Attribute WriteVirtualCookie.VB_Description = "Writes a virtual cookie.  This must be done before any call to WriteCGI.  The first WriteCGI will commit all of the virtual cookies to the user's browser."
Attribute WriteVirtualCookie.VB_HelpID = 31
    ' first, find out if the cookie is already out there!
    Dim iPos As Integer, iEnd As Integer
    
    If (IsMissing(fNotUnique)) Then
        DeleteVirtualCookie sName
    ElseIf (Not fNotUnique) Then
        DeleteVirtualCookie sName
    Else
        DeleteVirtualCookie sName, sValue
    End If
    sVirtualCookies = sVirtualCookies + IIf(Len(sVirtualCookies) = 0, "", "&") + sName + "=" + sValue
    fModifiedVirtual = True
End Sub


' write http out to the client
Public Sub WriteCGI(sText As String, Optional fStartCGI As Variant)
Attribute WriteCGI.VB_Description = "Write out to CGI."
Attribute WriteCGI.VB_HelpID = 27
    Dim lWritten As Long, lReserved As Long
    Static hConsole As Long
    
    If (IsMissing(fStartCGI)) Then
        startCGI
    ElseIf (fStartCGI = True) Then
        startCGI
    End If
   
    lReserved = 0
    If hConsole = 0 Then
        hConsole = GetStdHandle(STD_OUTPUT_HANDLE)
    End If
    WriteFile hConsole, (sText), Len(sText), lWritten, lReserved
End Sub
' read input from the client (if the info was submitted POST)
Private Function ReadPOST() As String
    ' only works with POST!!!
    Static sText As String
    If (sText <> "") Then
        ReadPOST = sText
        Exit Function
    End If
    Dim lWritten As Long, lReserved As Long
    Dim hConsole As Long
    
    sText = Space(MaxPost)
    lReserved = 0
    If (hConsole = 0) Then
        hConsole = GetStdHandle(STD_INPUT_HANDLE)
    End If
    ReadFile hConsole, sText, Len(sText) - 1, lWritten, lReserved
    sText = Trim$(sText)
    sText = Left$(sText, Len(sText) - 1) ' kill \0
    ReadPOST = sText
End Function
Private Sub Class_Initialize()
    MaxPost = DEFAULT_MAX_POST
End Sub


